function allsubplots(g,k)
// shows subplots of closed loop poles/zeros, step responses etc. 
//RLTOOL for scilab (c) Ishan Pendharkar. 

if k==[] then,
	xinfo(['Select a point on the rootlocus']);
	return;
	end; 
// no subplots are to be drawn if the point is not legitimate, i.e. not on root
// locus

setmenu(0, 'Response', [4]); // sets the details button on
if Knumber ==1 then,
	g_closedloop=syslin('c',g*k/(1+g*k)); // unity feedback configuration
else,
	g_closedloop=syslin('c',g/(1+k*g)); // k in feedback
end;
// closedloop for k in feedback or k in forward path
//markpoles(r);
fig(1);
xname('Rltool-1.5: closed loop plots');
xbasc(1);	
xinfo('Closed loop responses for gain = '+string(k)+'.');
subplot(221)
	polezeroplot(g_closedloop); //display polezero plot
subplot(222)
	//xtitle('Closed loop frequency response');
	modified_bode(g_closedloop,Frunits); 
subplot(223)
	substep_response(g_closedloop); //'sub' means subplot.
subplot(224)
	modified_gainplot(syslin('c',1/(1+k*g)),Frunits);
	xtitle('Sensitivity plot');

// if main window is closed... exit
	if winsid()==0 then,
	xdel(0);
	return;
	else,
	fig(0);
	xselect();
	end;
clear g_closedloop;
return;

	
