function rlt()
//RLTOOL for scilab (c) Ishan Pendharkar. 
//function the main programme! 

// set oldstyle on for scilab version 3.0 only.
version=getversion();
position=grep(version,'3.0');  
if position<>[] then,
set("old_style","on") // required for scilab 3.0. comment for lower versions
else,
disp("Please consider upgrading to Scilab-3.0")
end;
clear position;
fig(0);
delmenu(0,'Edit');
delmenu(0,'3D Rot.');
xname('Rltool-1.5 main window');

//****************Default global values***********
 choice=1; // root locus or frequency design mode
 gridon=0;
 diry=pwd(); 
 kevans=1000; 
  fminmag=0.01;
 fmaxmag=1000; 
 magstep=0.01;
 
 fminnyq=0.01; 
 fmaxnyq=1000;
 nyqstep=0.01;
 
 fminbode=0.01; 
 fmaxbode=1000;
 bodestep=0.01; 
 
 tmax=5; 
 tstep=0.05;
 
 fminsens=0.01;
 fmaxsens=1000; 
 sensstep=0.01;	
 zeta=0.7;
 wn=1;
 browser_path='mozilla ' // default browser path
 
 s=poly(0,'s');
 g=1/s;
 gold=g;
 g_save=g;
 
 MAG=1;
 FREQ=1;
 CYCLES=1;
 Knumber=1;
 Frunits='r' // Frequency unit default is rad/sec
 
//**************************************************
global g MAG FREQ CYCLES Frunits
//**************** MENUS****************************
addmenu(0,'Grid',['On';'Off';'Zeta/Wn';'sgrid']);
Grid_0(1)='gridon=1; whichplot()';
Grid_0(2)='gridon=0; whichplot()';
Grid_0(3)='zetaplot(zeta,wn)';
Grid_0(4)='whichplot(); sgrid()';

addmenu(0,'Response',['Closed Loop';'Nyquist';'Nichols';'Details';'Popov']);
Response_0(1)='response_select(g)';
Response_0(2)='nyq(g)';
Response_0(3)='blacksplot(g)'
Response_0(4)='displayalldetails(g,k)'
Response_0(5)='popov_plot(g)';

addmenu(0,'Design',['Root Locus';'Frequency']);
Design_0(1)='choice=1; whichplot()';
Design_0(2)='choice=2; whichplot()';

addmenu(0,'Plant',['Undo';'Add Pole';'Add Zero';'Remove Pole';'Remove Zero';'Add Cascade';'Remove Cascade';'Edit Plant']);

Plant_0(1)='g=undo()';
Plant_0(2)='g=addpole(g)';
Plant_0(3)='g=addzero(g)';
Plant_0(4)='g=rmpole(g)';
Plant_0(5)='g=rmzero(g)';
Plant_0(6)='g=addplant()';
Plant_0(7)='g=rmplant(g)';
Plant_0(8)='g=rl(g)';

addmenu(0,'Save',['Save';'Load']);
Save_0(1)='saveplant(g);'
Save_0(2)='g=loadplant();'

addmenu(0,'Settings',['Root Locus';'Mag. plot';'Nyquist-Nichols Plot';'Bode Plot';'Dynamic Response';'Sensitivity Plot';'Graphics attributes';'Gain configuration';'Frequency units';'HTML viewer']);
Settings_0(1)='[ok,kevans]=rlsettings()';
Settings_0(2)='[ok,fminmag,fmaxmag,magstep]=magsettings()';
Settings_0(3)='[ok,fminnyq,fmaxnyq,nyqstep]=nyqsettings()';
Settings_0(4)='[ok,fminbode,fmaxbode,bodestep]=bodesettings()';  
Settings_0(5)='[ok,tmax,tstep]=dynamicsettings()';
Settings_0(6)='[ok,fminsens,fmaxsens,sensstep]=senssettings()';
Settings_0(7)='xsetm();g=rl(g)';
Settings_0(8)='Knumber=Ksettings()';
Settings_0(9)='Frunits=Frunitssettings()';
Settings_0(10)='bowser_path=browserpathsettings()';

addmenu(0,'Help',['Root Locus';'Magnitude Plot';'Nyquist-Nichols Plot';'Bode Plot';'Closed loop responses';'Sensitivity';'Settings';'Load/Save';'About';'License';'To Do';'HTML manual']); 
Help_0(1)='HELProotlocus()';
Help_0(2)='HELPmagplot()';
Help_0(3)='HELPnyqplot()';
Help_0(4)='HELPbodeplot()';
Help_0(5)='HELPclosedloopresponse()';
Help_0(6)='HELPsensitivityplot()';
Help_0(7)='HELPsettings()';
Help_0(8)='HELPloadandsave()';
Help_0(9)='HELPabout()';
Help_0(10)='HELPlicense()';
Help_0(11)='HELPtodo()';
Help_0(12)='HELPloadmanual()';

//************************************************************
//*********** Welcome Message display********

WelcomeMsg=['Enjoy using Rltool, version 1.5!';
	    'for Scilab 3.0, Linux and WinXP.';	
	    '(c) Ishan Pendharkar, IIT Bombay, India.';
	    'Click on the rootlocus to know the gain';
	    'and closed loop poles. A short online help';
	    'is also included. Click Help to see this.';
	    'To open an already saved session click on';
	    'Open, else click on New .'	 
	   ]
xinfo('Welcome to RLTOOL, 1.5. Click on HELP menu for detailed online help');
Check=execstr('load '+' .rltoolcfg-1.5.sci','errcatch'); 
//check if .rltoolcfg.sci is present. Loads previous data into rltool 

WelcomeNumber=x_message(WelcomeMsg,['Open','New']);
	
	if WelcomeNumber==1 then, //open existing file
	g=loadplant();
	else,
	g=rl(g);
	end;
k=[]; // initialize k to null k is the "gain".
oldk=[]
global k oldk;
while winsid()<> []
	//if user closes window, program stops!
		// wait for a mouse click in any window
		[c_i,c_x,c_y,c_w,c_m]=xclick()
		// check if click on a menu item
		valid_click=grep(c_m,'execstr'); 
    		if c_i==0 & c_w==0 then, //if click on main window...
			k=getgain(c_x,c_y); // get gain on root locus
				if k > 0 then,
				oldk=k; // save an older click
				end;
			else if  valid_click==1 then, // if click on menu
				gold=g;	// update old g	
				//g=gold; // save this g as g old 
				execstr(c_m)  
		     end;	
		end;

	
,else
Check=execstr('save '+' .rltoolcfg-1.5.sci','errcatch');
end;


 
